<template>
  <q-page class="constrain q-pa-md">
    <transition
      appear
      enter-active-class="animated fadeIn"
      leave-active-class="animated fadeOut"
    >
      <div
        v-if="showAppNotificationBanner && pushNotificationSupported"
        class="bg-primary"
      >
        <div class="constrain">
          <q-banner class="q-mb-md">
            <template v-slot:avatar>
              <q-icon name="eva-bell-outline" />
            </template>
            Would you like to enable notification?

            <template v-slot:action>
              <q-btn
                @click="enableNotifications"
                color="primary"
                flat
                label="YES"
              />
              <q-btn
                @click="showAppNotificationBanner = false"
                color="primary"
                flat
                label="LATER"
              />
              <q-btn
                @click="neverShowAppNotificationBanner"
                color="primary"
                flat
                label="NEVER"
              />
            </template>
          </q-banner>
        </div>
      </div>
    </transition>
    <div class="row q-col-gutter-lg">
      <div class="col-12 col-sm-8">
        <template v-if="!loadingPosts && posts.length">
          <q-card
            v-for="post in posts"
            :key="post.id"
            class="card-post q-mb-md"
            bordered
            flat
          >
            <q-item>
              <q-item-section avatar>
                <q-avatar>
                  <img src="https://cdn.quasar.dev/img/boy-avatar.png" />
                </q-avatar>
              </q-item-section>

              <q-item-section>
                <q-item-label class="text-bold">Ravish__dhawan</q-item-label>
                <q-item-label caption>
                  {{ post.location }}
                </q-item-label>
              </q-item-section>
            </q-item>

            <q-separator />

            <q-img :src="post.imageUrl" />

            <q-card-section>
              <div>{{ post.caption }}</div>
              <div class="text-caption text-grey">
                {{ post.date | niceDate }}
              </div>
            </q-card-section>
          </q-card>
        </template>
        <template v-else-if="!loadingPosts && !posts.length">
          <h5 class="text-center text-grey">No posts yet.</h5>
        </template>
        <template v-else>
          <q-card flat bordered>
            <q-item>
              <q-item-section avatar>
                <q-skeleton type="QAvatar" animation="fade" size="40px" />
              </q-item-section>

              <q-item-section>
                <q-item-label>
                  <q-skeleton type="text" animation="fade" />
                </q-item-label>
                <q-item-label caption>
                  <q-skeleton type="text" animation="fade" />
                </q-item-label>
              </q-item-section>
            </q-item>

            <q-skeleton height="200px" square animation="fade" />

            <q-card-section>
              <q-skeleton type="text" class="text-subtitle2" animation="fade" />
              <q-skeleton
                type="text"
                width="50%"
                class="text-subtitle2"
                animation="fade"
              />
            </q-card-section>
          </q-card>
        </template>
      </div>

      <div class="col-4 large-screen-only">
        <q-item class="fixed">
          <q-item-section avatar>
            <q-avatar size="48px">
              <img src="https://cdn.quasar.dev/img/boy-avatar.png" />
            </q-avatar>
          </q-item-section>

          <q-item-section>
            <q-item-label class="text-bold">Ravish__dhawan</q-item-label>
            <q-item-label caption>
              Ravish dhawan
            </q-item-label>
          </q-item-section>
        </q-item>
      </div>
    </div>
  </q-page>
</template>

<script>
import { date } from "quasar";

export default {
  name: "PageHome",
  data() {
    return {
      posts: [],
      loadingPosts: false,
      showAppNotificationBanner: false
    };
  },
  computed: {
    serviceWorkerSupported() {
      if ("serviceWorker" in navigator) return true;
      return false;
    },
    pushNotificationSupported() {
      if ("PushManager" in window) return true;
      return false;
    }
  },
  methods: {
    getPosts() {
      this.loadingPosts = true;
      this.$axios
        .get(`${process.env.API}/posts`)
        .then(response => {
          this.posts = response.data;
          this.loadingPosts = false;
        })
        .catch(err => {
          this.$q.dialog({
            title: "Error",
            message: "Could not get your posts."
          });
          this.loadingPosts = false;
        });
    },
    initNotificationBanner() {
      let neverShowAppNotificationBanner = this.$q.localStorage.getItem(
        "neverShowAppNotificationBanner"
      );
      if (!neverShowAppNotificationBanner) {
        this.showAppNotificationBanner = true;
      }
    },
    enableNotifications() {
      if (this.pushNotificationSupported) {
        Notification.requestPermission(result => {
          console.log(result);
          this.neverShowAppNotificationBanner();
          if (result == "granted") {
            this.displaygrantedNotification();
          }
        });
      }
    },
    displaygrantedNotification() {
      // new Notification("You are subcribed to notification", {
      //   body: "Thanks for subcribing",
      //   icon: "icons/icon-128x128.png",
      //   image: "icons/icon-128x128.png",
      //   badge: "icons/icon-128x128.png",
      //   vibrate: [100, 50, 200],
      //   tag: "confirm-notification",
      //   renotify: true
      // });
      if (this.serviceWorkerSupported && this.pushNotificationSupported) {
        navigator.serviceWorker.ready.then(swreg => {
          swreg.showNotification("You are subcribed to notification", {
            body: "Thanks for subcribing",
            icon: "icons/icon-128x128.png",
            image: "icons/icon-128x128.png",
            badge: "icons/icon-128x128.png",
            vibrate: [100, 50, 200],
            tag: "confirm-notification",
            renotify: true
          });
        });
      }
    },
    neverShowAppNotificationBanner() {
      this.showAppNotificationBanner = false;
      this.$q.localStorage.set("neverShowAppNotificationBanner", true);
    }
  },
  filters: {
    niceDate(value) {
      return date.formatDate(value, "MMMM D h:mmA");
    }
  },
  created() {
    this.getPosts();
    this.initNotificationBanner();
  }
};
</script>

<style lang="sass">
.card-post
  .q-img
    min-height: 200px
</style>
